//
//  TestCIFilter.m
//  TestCIFilter
//
//  Created by Kevin Gross on 10/8/10.
//  Copyright 2010 Kevin Gross www.art144.com. All rights reserved.
//

#import "TestCIFilter.h"
#import <QuartzCore/QuartzCore.h>

@implementation TestCIFilter

static CIKernel *testCIKernel = nil;

+ (void)registerFilter
{
    [CIFilter registerFilterName: @"TestCI"  constructor: self
				 classAttributes: [NSDictionary dictionaryWithObjectsAndKeys:
								   
								   @"Test CI", kCIAttributeFilterDisplayName,
								   
								   [NSArray arrayWithObjects:
									kCICategoryColorAdjustment, kCICategoryVideo, kCICategoryStillImage,
									kCICategoryInterlaced, kCICategoryNonSquarePixels,
									nil],                              kCIAttributeFilterCategories,
								   
								   nil]];
}

+ (CIFilter *)filterWithName: (NSString *)name
{
    CIFilter  *filter;
	
    filter = [[self alloc] init];
    return [filter autorelease];
}

- (id)init
{
    if(testCIKernel == nil)
    {
		NSError	*err;
        NSBundle *bundle = [NSBundle bundleForClass: [self class]];
        NSString *code = [NSString stringWithContentsOfFile: [bundle pathForResource: @"TestCIFilter" ofType: @"cikernel"] 
												   encoding:NSUTF8StringEncoding error:&err];
        NSArray *kernels = [CIKernel kernelsWithString: code];
		
        testCIKernel = [[kernels objectAtIndex:0] retain];
    }
    return [super init];
}

- (CIImage *)outputImage
{
    CISampler *src = [CISampler samplerWithImage: inputImage];
	
	NSArray * outputExtent = [NSArray arrayWithObjects:
							  [NSNumber numberWithInt:0],
							  [NSNumber numberWithInt:0],
							  [NSNumber numberWithFloat:[inputImage extent].size.width],
							  [NSNumber numberWithFloat:[inputImage extent].size.height],nil];
	
	[testCIKernel setROISelector:@selector(regionOf:destRect:userInfo:)];
	
	return [self apply: testCIKernel, src, inputColor, 
			kCIApplyOptionDefinition, [src definition], kCIApplyOptionExtent, outputExtent, nil];
	
}


- (CGRect) regionOf:(int)samplerIndex
		   destRect:(CGRect)r
		   userInfo:obj
{
	
	return r;
	//return CGRectInfinite;
}

- (NSDictionary *)customAttributes
{
    return [NSDictionary dictionaryWithObjectsAndKeys:
			

			
			@"TestCI", kCIAttributeFilterName, // this is needed since the filter is registered under a different name than the class
			nil];
}


@end
